<script lang="ts">
import Vue from 'vue';
import SlpHorizontalRule from '../common/horizontal-rule.vue';
import { IsMobileMixin } from '../../mixins';
import SolutionsResourcesVideoCard from './resource-cards-video-card.vue';

export default Vue.extend({
  name: 'SolutionsResourceCards',
  components: { SlpHorizontalRule, SolutionsResourcesVideoCard },
  mixins: [IsMobileMixin],
  props: {
    data: {
      type: Object,
      required: true,
      default: null,
    },
    offset: {
      type: Number,
      required: false,
      default: 0,
    },
  },
  data() {
    return {
      categories: [],
      selectedCategory: '',
    };
  },
  beforeMount(): void {
    if (this.data.grouped) {
      this.categories = Array.from(
        new Set(this.data.cards.map((card: any) => card.event_type)),
      );
    }

    [this.selectedCategory] = this.categories;
  },
  methods: {
    switchCategory(category: string) {
      this.selectedCategory = category;
    },
  },
});
</script>

<template>
  <SlpContainer :class="`resource-cards--${data?.align || ''}`">
    <SlpRow class="slp-mb-md-96 slp-mt-md-96 slp-mt-64">
      <SlpColumn v-if="offset !== 0" :cols="offset" />
      <SlpColumn>
        <div class="resources-block__header" :class="{ grouped: data.grouped }">
          <SlpTypography tag="h2" variant="heading2-bold">
            {{ data.title || 'Resources' }}</SlpTypography
          >
          <SlpButton
            v-if="!data.grouped"
            variant="tertiary"
            style="padding-left: 0"
            :href="data.link?.href ?? '/resources/'"
            :data-ga-name="data.link?.data_ga_name ?? `view all resources`"
            :data-ga-location="data.link?.data_ga_location ?? `resource cards`"
            class="resources-block__button"
            >{{ data.link?.text ?? `View all resources` }}
            <SlpIcon
              name="chevron-lg-right"
              variant="product"
              hex-color="#171321"
            />
          </SlpButton>
        </div>
        <div v-if="data.grouped" class="resources_tabs">
          <SlpTypography
            v-for="category in categories"
            :key="category"
            variant="body2-bold"
            :class="{ active: category === selectedCategory }"
            @click.native="switchCategory(category)"
          >
            {{ $pluralize(category) }}
          </SlpTypography>
        </div>
        <SlpHorizontalRule v-if="!data.grouped" class="resources-block__line" />
        <SlpRow class="resources-container">
          <SlpColumn
            v-for="(card, index) in data.cards"
            v-show="
              (data.grouped && card.event_type === selectedCategory) ||
              !data.grouped
            "
            :key="index"
            :cols="data.column_size"
            class="slp-mb-md-48"
            size="lg"
          >
            <SolutionsResourcesVideoCard
              v-if="card.event_type.toLowerCase() === 'video'"
              :card-data="card"
            />
            <a
              v-else
              :href="card.href"
              class="resources-block"
              :data-ga-name="card.data_ga_name"
              :data-ga-location="card.data_ga_location"
              :data-aos="card.aos_animation"
              :data-aos-duration="card.aos_duration"
            >
              <div class="resources-block__wrapper">
                <div class="resources-block__content-top">
                  <div class="resources-block__icon slp-flex">
                    <SlpIcon
                      v-if="card.icon"
                      :name="card.icon.name"
                      :variant="card.icon.variant"
                      :alt="card.icon.alt"
                      slp-color="text-300"
                    />
                    <SlpTypography
                      tag="p"
                      variant="body2"
                      class="resources-block__type"
                      >{{ card.event_type }}
                    </SlpTypography>
                  </div>
                  <nuxt-img
                    class="resources-block__image slp-my-24"
                    :src="
                      card.image ||
                      card.fallback_image ||
                      '/nuxt-images/resources/fallback/img-fallback-cards-infinity.png'
                    "
                    alt=""
                    loading="lazy"
                  />
                  <SlpTypography
                    v-if="card.title"
                    tag="h3"
                    variant="heading4-bold"
                    class="slp-mb-16"
                    >{{ card.title }}
                  </SlpTypography>
                  <SlpTypography
                    :tag="card.description ? 'p' : 'h3'"
                    variant="body1"
                    >{{ card.header || card.description }}
                  </SlpTypography>
                  <SlpTypography
                    v-if="card.date"
                    tag="p"
                    variant="body1"
                    class="slp-my-8"
                    >{{ card.date }}
                  </SlpTypography>
                </div>
                <div v-if="card.text" class="resources-block__content-text">
                  <SlpTypography variant="body1">{{ card.text }}</SlpTypography>
                </div>
                <div class="resources-block__content-bottom">
                  <SlpTypography
                    variant="button"
                    tag="span"
                    class="resources-block__link"
                    >{{ card.link_text }}
                    <SlpIcon
                      class="slp-ml-8"
                      variant="product"
                      name="chevron-lg-right"
                    />
                  </SlpTypography>
                </div>
              </div>
            </a>
          </SlpColumn>
        </SlpRow>
      </SlpColumn>
    </SlpRow>
  </SlpContainer>
</template>

<style scoped lang="scss">
.resource-cards {
  &--left {
    .resources-block__header.grouped {
      justify-content: left;
    }
    .resources_tabs {
      justify-content: flex-start;

      span {
        text-align: left;
        padding: 0 $spacing-24 $spacing-16 $spacing-24;
        margin-left: 0;
        margin-right: 0;
        width: auto;
      }
    }
  }
}

div.resources-container {
  @media (max-width: $breakpoint-lg) {
    flex-wrap: nowrap;
    overflow: scroll;
  }
}
.slp-btn {
  color: $color-text-300;
}

.resources_tabs {
  display: flex;
  justify-content: space-around;
  width: 100%;
  overflow: scroll;
  position: relative;
  &::-webkit-scrollbar {
    display: none;
  }
  margin: $spacing-48 0;
  @media (max-width: $breakpoint-md) {
    justify-content: flex-start;
  }
  span {
    transition: all 0.2s;
    cursor: pointer;
    width: auto;
    padding: 0 $spacing-24 $spacing-16 $spacing-24;
    white-space: nowrap;
    text-align: center;
    border-bottom: 4px solid transparent;
    position: relative;
  }
  .active {
    border-bottom: 4px solid #7759c2;
  }
  &:before {
    content: '';
    height: 2px;
    width: 100vw;
    background: $color-surface-900;
    position: absolute;
    bottom: 0;
    @media (max-width: $breakpoint-md) {
      width: 100%;
    }
  }
}

.slp-text-button,
.slp-btn-ghost {
  font-weight: 600;
}

.slp-btn svg,
.resources-block__link svg {
  vertical-align: middle;
  margin-left: $spacing-4;
  justify-content: center;
}

.resources-block {
  cursor: pointer;
  display: flex;
  position: relative;
  height: 100%;
  min-width: 300px;
  @media (min-width: $breakpoint-md) {
    margin: $spacing-16 $spacing-16 $spacing-16 0;
  }

  &__wrapper {
    display: flex;
    flex-direction: column;
    transition: all 0.3s ease-in-out;
    justify-content: space-between;
    padding: $spacing-32 $spacing-16;
    flex: 1;

    &:hover {
      background: $color-surface-900;
      border-bottom-right-radius: 100px;
    }
  }

  &__header {
    width: 100%;
    display: flex;
    flex-direction: column;

    @media (min-width: $breakpoint-md) {
      flex-direction: row;
      justify-content: space-between;
      align-items: center;
    }

    &.grouped {
      justify-content: center;
    }
  }

  &__line {
    border-top: 2px solid $color-surface-400;

    &.slp-hr {
      margin: $spacing-32 0;
    }
  }

  &__image {
    width: 100%;
    max-height: 200px;
    max-width: 318px;
    height: 200px;
    object-fit: cover;
  }

  &__link {
    color: $color-text-300;
    padding-left: 0;
    display: flex;
    align-items: center;
  }

  &__type {
    margin-left: $spacing-8;
  }

  &__content-text {
    color: $color-text-300;
  }

  &__content-top {
    p,
    h3 {
      color: $color-text-300;
    }
  }

  &__icon {
    .resources-block__image {
      max-width: 1rem;
    }
  }
  &__button {
    @media (min-width: $breakpoint-md) {
      margin-left: auto;
      min-width: fit-content;
      margin-left: 20%;
    }
  }
}
</style>
